#include <sys/socket.h>      /* per socket, bind, ecc */
#include <netinet/in.h>      /* per INADDR_ANY */
#include <arpa/inet.h>       /* per inet_aton */
#include "lisocket.h"

int
make_socket (int port)
{
  int sock;
  struct sockaddr_in indirizzo;

  /* Creazione del socket locale */ 
  sock = socket (PF_INET, SOCK_STREAM, 0);
  if (sock < 0)
    return -1;
  /* Creazione dell'indirizzo Internet locale */
  indirizzo.sin_family = AF_INET;
  indirizzo.sin_addr.s_addr = htonl (INADDR_ANY);
  indirizzo.sin_port = htons (port);
  /* Associazione del socket all'indirizzo Internet locale */
  if (bind (sock, (struct sockaddr *) &indirizzo, \
      sizeof (indirizzo)) < 0)
    return -1;
  /* Configurazione della coda delle richieste di connessione */
  if (listen (sock, 1) < 0)
    return -1;
  return sock;
}

int
connect_to_socket (int port, char *hostname)
{
  int sock;
  struct sockaddr_in indirizzo;

  /* creazione del socket locale */
  sock = socket (PF_INET, SOCK_STREAM, 0);
  if (sock < 0)
    return -1;
  /* creazione dell'indirizzo Internet del socket remoto */
  indirizzo.sin_family = AF_INET;
  if (inet_aton (hostname, &indirizzo.sin_addr) == 0) 
    return -1;
  indirizzo.sin_port = htons (port);
  /* connessione del socket locale al socket remoto */
  if (connect (sock, (struct sockaddr *) &indirizzo, \
      sizeof (indirizzo)) < 0)
    return -1;
  return sock;
}
